#!/usr/bin/env node
const fs = require("fs");
const path = require("path");
const { Command } = require("commander");
const _ = require("lodash");
const { loadTs, findAllFile } = require("./utils.js");
const pkg = require("./package.json");
const { complier, io } = require("./dist/complier.js");

const commander = new Command();

commander.version(pkg.version);

commander
  .command("go [dir]")
  .description("编译当前目录下的文件")
  .option("-c, --config", "读取指定配置文件")
  .action(async (dir = "./") => {
    const _path = path.join(process.cwd(), dir);
    // * read config
    // * 判断有无配置文件
    const { entry, output } = require(`${_path}/ecode.config.js`);
    // console.log(output);
    const entryPath = path.join(_path, entry);
    findAllFile(entryPath, "ts").map((it) => {
      const content = loadTs(it);
      const result = complier(content);
      io.create(result, path.join(_path, output));
    });
    // const config = _config;
  });

commander.version(pkg.version);
commander.parse();
