// import { terser } from "rollup-plugin-terser";
import esbuild from "rollup-plugin-esbuild";
import dts from "rollup-plugin-dts";

export default [
  {
    input: "src/complier/index.ts",
    output: {
      format: "cjs",
      file: "dist/complier.js",
      sourcemap: true,
      exports: "default"
    },
    // plugins: [esbuild({ target: 'esnext' }), terser()],
    plugins: [esbuild({ target: "esnext" })],
    external: ["fs", "readline", "js-md5", "colors/safe", "uid"]
  },
  {
    input: "src/render/index.ts",
    output: {
      format: "es",
      file: "dist/render.js",
      sourcemap: true
      // exports: "default"
    },
    plugins: [esbuild({ target: "esnext" })],
    external: ["fs", "readline", "js-md5", "colors/safe", "uid"]
  },
  {
    input: "src/render/index.ts",
    output: {
      format: "es",
      file: "dist/render.d.ts"
    },
    plugins: [dts()],
    external: ["fs", "readline", "js-md5", "colors/safe", "uid"]
  }
];
