import Render from "./render";
import { elementStruct } from "./types";

type elementType = {};

type initType = {
  tag: string;
  children: any[];
  class: (string | object)[];
  content: string;
};

export default class Element extends Render implements elementType {
  tag;
  class;
  content;
  constructor({ tag, children, content, class: cls }: initType) {
    super({ children });
    this.tag = tag;
    this.class = cls;
    this.content = content;
  }

  render(): elementStruct {
    return {
      type: "element",
      imports: [...this.children.imports],
      template: `<${this.tag} [ngClass]="${this.class}">${this.content}</${this.tag}>`,
      data: [...this.children.data],
      init: [...this.children.init],
      methods: [...this.children.methods]
    };
  }
}
