import Render from "./render";
import { elementStruct } from "./types";
import * as _ from "lodash";

export default class Module extends Render {
  id;
  link;
  childrens;
  constructor({ id, children }) {
    super({ children });
    if (!id) {
      console.log("Error: Please enter id in Module");
      return;
    }
    this.id = Render.toCamel(id);
    this.link = children.map((it) => {
      const { type } = it.render();
      return { name: `${Render.toCamel(it.id)}`, type };
    });
    this.childrens = children;
  }
  render(): elementStruct {
    return {
      id: this.id,
      type: "module",
      imports: [
        { target: [{ name: "NgModule", type: "base" }], from: "@angular/core" },
        {
          target: [{ name: "CommonModule", type: "module" }],
          from: "@angular/common"
        },
        ...this.children.imports
      ],
      link: [...this.link],
      children: [...this.childrens],
      components: [...this.children.components]
    };
  }
}
