type importsType = {
  target:
    | string
    | string[]
    | {
        name: string
        type: 'module' | 'component' | 'service' | 'directive'
        inject: { name: string; export?: boolean }
      }[]
  from: string
  effect?: string
  ignore?: boolean
}[]

export type necessaryStruct = {
  render: () => elementStruct
}

export type callbackStruct = {}

export type elementStruct =
  | {
      type: 'element'
      template: string
      data: string[]
      methods: string[]
      imports: importsType
      components?: any[]
      init?: any[]
      filters?: string[]
      watch?: string[]
      computed?: string[]
    }
  | {
      type: 'component'
      id: string
      template: string
      link: { name: string; type: 'scss' }[]
      imports: importsType
      data: { name: string; init: any; type?: any }[]
      init: any[]
      methods: any[]
      components: any[]
    }
  | {
      type: 'module'
      id: string
      imports: importsType
      link: { name: string; type: 'component' }[]
      components: any[]
      children: any[]
    }
  | {
      type: 'service'
      imports: importsType
    }
