const esbuild = require('esbuild')
const fs = require('fs')
const path = require('path')
const _ = require('lodash')

const loadTs = (url) => {
  const { errors, outputFiles } = esbuild.buildSync({
    entryPoints: [url],
    bundle: true,
    format: 'cjs',
    write: false,
  })
  if (errors.length !== 0) {
    throw new Error(JSON.stringify(errors))
  }
  const code = new TextDecoder().decode(outputFiles[0].contents)
  const sourceExport = eval(code)
  return sourceExport.default
}

const findAllFile = (startPath, filterSuffix, ignoreDir = ['node_modules']) => {
  if (!fs.existsSync(startPath)) {
    return []
  }
  if (_.every(ignoreDir, (ignore) => startPath.includes(ignore))) {
    return []
  }
  return fs
    .readdirSync(startPath)
    .map((dirInner) => {
      dirInner = path.resolve(startPath, dirInner)
      const stat = fs.statSync(dirInner)
      return stat.isDirectory()
        ? findAllFile(dirInner, filterSuffix, ignoreDir)
        : dirInner.endsWith(filterSuffix)
        ? dirInner
        : []
    })
    .flat(Infinity)
}

module.exports = {
  loadTs,
  findAllFile,
}
